import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SpringLayout;

import java.awt.Container;
import java.awt.Dimension;

public class Main {
    public static void main(String[] args) {
        Artista ivycomb = new Artista("ivycomb", 2000, "Canada");
        Artista stephanafro = new Artista("Stephanafro", -1, "USA");
        Brano pennyPinched = new Brano("Penny Pinched", "pop", 2, 15, ivycomb, stephanafro);
        Brano vancouver = new Brano("Vancouver", "pop", 3, 42, ivycomb, stephanafro);
        Brano terminal18 = new Brano("Terminal 18", "pop", 3, 49, ivycomb, stephanafro);

        Playlist playlist = new Playlist(pennyPinched, vancouver, terminal18);

        Artista caparezza = new Artista("Caparezza", 1973, "Italia");
        Artista diegoPerrone = new Artista("Diego Perrone", 1975, "Italia");
        Brano faiDaTela = new Brano("Fai Da Tela", "hip hop", 3, 59, caparezza, diegoPerrone);
        Brano micaVanGogh = new Brano("Mica Van Gogh", "hip hop", 3, 55, caparezza);
        Brano nonMeLoPossoPermettere = new Brano("Non me lo posso permettere", "hip hop", 3, 46, caparezza);

        playlist.aggiungiInCoda(faiDaTela);
        playlist.aggiungiInCoda(micaVanGogh);
        playlist.aggiungiInCoda(nonMeLoPossoPermettere);

        JFrame frame = new JFrame("Playlist");
        frame.setSize(new Dimension(500, 250));
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        SpringLayout layout = new SpringLayout();
        frame.setLayout(layout);

        JLabel testoBranoCorrente = new JLabel(playlist.corrente().toString());
        frame.add(testoBranoCorrente);

        JButton bottoneProssimo = new JButton("Prossimo");
        bottoneProssimo.addActionListener(e -> {
            if(e.getSource() != bottoneProssimo) return;
            Brano nuovoBrano = playlist.prossimo();
            if(nuovoBrano != null) {
                testoBranoCorrente.setText(nuovoBrano.toString());
            }
        });
        frame.add(bottoneProssimo);

        JButton bottonePrecedente = new JButton("Precedente");
        bottonePrecedente.addActionListener(e -> {
            if(e.getSource() != bottonePrecedente) return;
            Brano nuovoBrano = playlist.precedente();
            if(nuovoBrano != null) {
                testoBranoCorrente.setText(nuovoBrano.toString());
            }
        });
        frame.add(bottonePrecedente);

        JCheckBox opzioneShuffle = new JCheckBox("Shuffle");
        opzioneShuffle.addActionListener(e -> {
            if(e.getSource() != opzioneShuffle) return;
            playlist.shuffle(opzioneShuffle.isSelected());
        });
        frame.add(opzioneShuffle);

        JCheckBox opzioneRepeat = new JCheckBox("Repeat");
        opzioneRepeat.addActionListener(e -> {
            if(e.getSource() != opzioneRepeat) return;
            playlist.repeat(opzioneRepeat.isSelected());
        });
        frame.add(opzioneRepeat);

        Container contentPane = frame.getContentPane();

        layout.putConstraint(SpringLayout.NORTH, testoBranoCorrente, 50, SpringLayout.NORTH, contentPane);
        layout.putConstraint(SpringLayout.HORIZONTAL_CENTER, testoBranoCorrente, 0, SpringLayout.HORIZONTAL_CENTER, contentPane);

        layout.putConstraint(SpringLayout.NORTH, bottonePrecedente, 20, SpringLayout.SOUTH, testoBranoCorrente);
        layout.putConstraint(SpringLayout.EAST, bottonePrecedente, 0, SpringLayout.HORIZONTAL_CENTER, contentPane);

        layout.putConstraint(SpringLayout.NORTH, bottoneProssimo, 0, SpringLayout.NORTH, bottonePrecedente);
        layout.putConstraint(SpringLayout.WEST, bottoneProssimo, 0, SpringLayout.EAST, bottonePrecedente);

        layout.putConstraint(SpringLayout.NORTH, opzioneRepeat, 10, SpringLayout.SOUTH, bottonePrecedente);
        layout.putConstraint(SpringLayout.HORIZONTAL_CENTER, opzioneRepeat, 0, SpringLayout.HORIZONTAL_CENTER, contentPane);

        layout.putConstraint(SpringLayout.NORTH, opzioneShuffle, 10, SpringLayout.SOUTH, opzioneRepeat);
        layout.putConstraint(SpringLayout.HORIZONTAL_CENTER, opzioneShuffle, 0, SpringLayout.HORIZONTAL_CENTER, contentPane);

        frame.setVisible(true);
    }
    
}
